type 'a t

exception Empty

val empty : 'a t
(* the empty stack *)

val push : 'a -> 'a t -> 'a t
(* push x s returns a new stack containing all elements of s in the same order plus x on top *)

val drop : 'a t -> 'a t
(* pop s returns a new stack containing all the elements of s in the same order except the topmost one. Raises Empty if s is empty *)

val top : 'a t -> 'a
(* top s returns the topmost element of s. Raises Empty if s is empty *)

val top_opt : 'a t -> 'a option
(* top_opt s returns Some x where x is the topmost element of s if s is not empty, or None if s is empty *)

val length : 'a t -> int
(* length s returns the number of elements in s. O(1) complexity *)
